<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDocumentosCompraERP ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfDocumentosCompraERP
 * @subpackage Arrays
 */
class ArrayOfDocumentosCompraERP extends AbstractStructArrayBase
{
    /**
     * The DocumentosCompraERP
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DocumentosCompraERP[]
     */
    public $DocumentosCompraERP;
    /**
     * Constructor method for ArrayOfDocumentosCompraERP
     * @uses ArrayOfDocumentosCompraERP::setDocumentosCompraERP()
     * @param \StructType\DocumentosCompraERP[] $documentosCompraERP
     */
    public function __construct(array $documentosCompraERP = array())
    {
        $this
            ->setDocumentosCompraERP($documentosCompraERP);
    }
    /**
     * Get DocumentosCompraERP value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DocumentosCompraERP[]|null
     */
    public function getDocumentosCompraERP()
    {
        return isset($this->DocumentosCompraERP) ? $this->DocumentosCompraERP : null;
    }
    /**
     * Set DocumentosCompraERP value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DocumentosCompraERP[] $documentosCompraERP
     * @return \ArrayType\ArrayOfDocumentosCompraERP
     */
    public function setDocumentosCompraERP(array $documentosCompraERP = array())
    {
        foreach ($documentosCompraERP as $arrayOfDocumentosCompraERPDocumentosCompraERPItem) {
            // validation for constraint: itemType
            if (!$arrayOfDocumentosCompraERPDocumentosCompraERPItem instanceof \StructType\DocumentosCompraERP) {
                throw new \InvalidArgumentException(sprintf('The DocumentosCompraERP property can only contain items of \StructType\DocumentosCompraERP, "%s" given', is_object($arrayOfDocumentosCompraERPDocumentosCompraERPItem) ? get_class($arrayOfDocumentosCompraERPDocumentosCompraERPItem) : gettype($arrayOfDocumentosCompraERPDocumentosCompraERPItem)), __LINE__);
            }
        }
        if (is_null($documentosCompraERP) || (is_array($documentosCompraERP) && empty($documentosCompraERP))) {
            unset($this->DocumentosCompraERP);
        } else {
            $this->DocumentosCompraERP = $documentosCompraERP;
        }
        return $this;
    }
    /**
     * Add item to DocumentosCompraERP value
     * @throws \InvalidArgumentException
     * @param \StructType\DocumentosCompraERP $item
     * @return \ArrayType\ArrayOfDocumentosCompraERP
     */
    public function addToDocumentosCompraERP(\StructType\DocumentosCompraERP $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DocumentosCompraERP) {
            throw new \InvalidArgumentException(sprintf('The DocumentosCompraERP property can only contain items of \StructType\DocumentosCompraERP, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->DocumentosCompraERP[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DocumentosCompraERP|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DocumentosCompraERP|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DocumentosCompraERP|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DocumentosCompraERP|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DocumentosCompraERP|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DocumentosCompraERP
     */
    public function getAttributeName()
    {
        return 'DocumentosCompraERP';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfDocumentosCompraERP
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
